<template>
  <div class="wrapper" ref="wrapper" :style="{ 'z-index': index }">
    <template v-if="animation">
      <transition name="overlay-fade">
        <div class="overlay" v-if="open && overlay"></div>
      </transition>
      <transition name="content-fade">
        <div class="popup-content" v-if="open"><slot /></div>
      </transition>
    </template>
    <template v-else>
      <div class="overlay" v-if="overlay"></div>
      <div class="popup-content"><slot /></div>
    </template>
  </div>
</template>

<script>
import Hammer from "hammerjs";
import { disableScroll, enableScroll } from "@/lib/scroll";

var index = 10;

export default {
  props: {
    overlay: {
      type: Boolean,
      default: true
    },
    animation: {
      type: Boolean,
      default: true
    }
  },

  data() {
    return {
      index: index++,
      open: false
    };
  },

  methods: {
    close() {
      if (this.open) {
        this.open = false;
        if (this.animation) {
          setTimeout(() => {
            this.$emit("close");
          }, 200);
        } else {
          this.$emit("close");
        }
      }
    }
  },

  mounted() {
    disableScroll();
    this.open = true;
    //const swipe = new Hammer.Swipe();
    //this.hammer = new Hammer.Manager(this.$refs.wrapper);
    //this.hammer.add(swipe);
    //this.hammer.on('swipedown', this.close.bind(this));
  },

  destroyed() {
    enableScroll();
    //this.hammer.destroy();
    index--;
  }
};
</script>

<style lang="scss" scoped>
.wrapper {
  position: fixed;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
}

.overlay {
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  background: rgba(0, 0, 0, 0.5);
  opacity: 1;
  transform: translateZ(0);

  &.overlay-fade-enter-active,
  &.overlay-fade-leave-active {
    transition: opacity 0.2s;
  }

  &.overlay-fade-enter,
  &.overlay-fade-leave-to {
    opacity: 0;
  }
}

.popup-content {
  position: absolute;
  left: 0;
  bottom: 0;
  width: 100%;
  height: 100%;
  opacity: 1;
  transform: translateZ(0);

  &.content-fade-enter-active,
  &.content-fade-leave-active {
    transition: opacity 0.2s;
  }

  &.content-fade-enter,
  &.content-fade-leave-to {
    opacity: 0;
  }
}
</style>
